import java.util.ArrayList;
import java.util.List;

public class Tree1 {
	public Data data;
	public List<Tree1> children;
	public Tree1(Data data) {
		this.data = data;
		children = new ArrayList<Tree1>();
	}
	public void addChild(Tree1 tree) {
		children.add(tree);
	}
	public void preorder(Visitor visitor) {
		visitor.visit(data);
		for (Tree1 child : children) {
			child.preorder(visitor);
		}
	}
	public boolean contains1(Data data) {
		if (this.data.compareTo(data) == 0) {
			return true;
		}
		for (Tree1 child : children) {
			if (child.contains1(data)) {
				return true;
			}
		}
		return false;
	}
	public boolean contains2(Data data) {
		V v = new V();
		v.data = data;
		preorder(v);
		return v.found;
	}
	private static class V implements Visitor {
		Data data; boolean found;
		public void visit(Data data) {
			found = found || this.data.compareTo(data) == 0;
		}
	}
}
