class MyList<T> {
	T head;
	MyList<T> tail;
}

public class Tree2 {
	public Data data;
	public MyList<Tree2> children;
	public Tree2(Data data) {
		this.data = data;
		children = new MyList<Tree2>();
	}
	public void addChild(Tree2 tree) {
		MyList<Tree2> pointer = children;
		for (; pointer.tail != null; pointer = pointer.tail);
		MyList<Tree2> next = new MyList<Tree2>();
		next.head = tree;
		pointer.tail = next;
	}
	public void preorder(Visitor visitor) {
		visitor.visit(data);
		for (MyList<Tree2> pointer = children.tail; pointer != null; pointer = pointer.tail) {
			pointer.head.preorder(visitor);
		}
	}
	public boolean contains1(Data data) {
		if (this.data.compareTo(data) == 0) {
			return true;
		}
		for (MyList<Tree2> pointer = children.tail; pointer != null; pointer = pointer.tail) {
			if (pointer.head.contains1(data)) {
				return true;
			}
		}
		return false;
	}
	public boolean contains2(Data data) {
		V v = new V();
		v.data = data;
		preorder(v);
		return v.found;
	}
	private static class V implements Visitor {
		Data data; boolean found;
		public void visit(Data data) {
			found = found || this.data.compareTo(data) == 0;
		}
	}
}
